#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************

# --------------------------------------------------------------
#
# Variables
#
# --------------------------------------------------------------
use Win32::Registry;

$debug = 1;
$| = 1;
#$# = 2;
$P = "dbamon_orantstat.pl";
$msgfile = "/tmp/dbamon_ora_tmp.txt";
$db_user = "internal";
$pass = "";

$os   = $ARGV[0];
$verb = $ARGV[1];
$arg1 = $ARGV[2];
$arg2 = $ARGV[3];
$arg3 = $ARGV[4];
$arg4 = $ARGV[5];

### Get hostname
%values="";
$Register = "System\\CurrentControlset\\Services\\tcpip\\Parameters";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
$hkey->GetValues(\%values);
foreach $value (keys(%values))
{
   $RegType      = $values{$value}->[1];
   $RegValue     = $values{$value}->[2];
   $RegKey       = $values{$value}->[0];
   $hostname = $RegValue if $RegKey eq "Hostname";
}
$hkey->Close();
$host = $hostname;

# Save Company name
open(NSLOOKUP, 'ipconfig/all|') || die "Error running ipconfig";
while(<NSLOOKUP>)
{
  ##print;
  @words = split;
  $verb1 = $words[0];
  $verb2 = $words[1];
  ##print "verb1=$verb1 verb2=$verb2\n";
  if ($verb1 eq "Host" && $verb2 eq "Name")
  {
    $compwork = $words[$#words]; 
    ##print "compwork=$compwork\n";
  }
}
close(NSLOOKUP);
chop $compwork;
@words = split(/\./,$compwork);
$nexttolast = $#words - 1;
$company = $words[$nexttolast];
#&msg("Company: $company");

$userid = Win32::LoginName();
$driver = "DBAmonOracle$os";

if ($os eq "")
{
  print "$P | Error: No OracleSID supplied\n";
  exit 1;
}
if ($verb eq "")
{
  print "$P | Error: No verb supplied\n";
  exit 1;
}

$sid_found = "false";

### Get list of sids that exist
%values="";
$Register = "SYSTEM\\CurrentControlSet\\Services";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey) || die "Cannot open registry $Register -$!";
$hkey->GetKeys(\@key_list);
$hkey->Close();

foreach $RegKey (@key_list)
{
   if ($RegKey =~ "OracleService")
   {
      $sid_cnt+=1;
      $sid_length = length ($RegKey);
      $sid = uc(substr ($RegKey,13,$sid_length));
      if ($sid eq $os)
      {
         $sid_found = "true";
      }
    }
}

if ($sid_ok eq "false")
{
   &error("\"$os\" not present -- OracleService$os not found\n");
}

### Get ORACLE_HOME
%values="";
$Register = "SYSTEM\\CurrentControlSet\\Services\\OracleService$os";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey) || die "Cannot open registry $Register -$!";
$hkey->GetValues(\%values);
$hkey->Close();

foreach $value (keys(%values))
{
   $RegKey   = $values{$value}->[0];
   $RegType  = $values{$value}->[1];
   $RegValue = $values{$value}->[2];
   $RegKey = lc($RegKey);

   if ($RegKey eq "imagepath")
   {
      @words = split (/\\/,$RegValue);
      $start_cmd = @words[-1];
      $_=$RegValue;
      s/$start_cmd//;
      s/bin//;
      $oh=$_;
      chop($oh);
      chop($oh);
      # print "ORACLE_HOME: $oh\n";
   }
 }

&msg("Starting - host=$host os=$os oh=$oh userid=$userid verb=$verb driver=$driver");

# Add $oh/bin to path
$path_orig   = $ENV{'Path'};
$path_new    = "${oh}/bin;" . $path_orig;
$ENV{"Path"} = $path_new;
$ENV{"Path"} .= "\\temp;";

$ENV{"ORACLE_SID"} = $os;
$ENV{"ORACLE_HOME"} = $oh;
##system("set");

# See if there is a pw file - if there is then use that as the pw
$f = "$oh\\net80\\admin\\.system";
if (-r "$f")
{
  $/="\n";
  chomp($pass = `type $f`);
  print "$P | Access shortcut ON \n";
}

if (length($verb) < 4)
{
  $command = "perl \\temp\\orantstat.pl $verb";
}
else
{
  $command = "perl \\temp\\orantstat_orantadmin.pl $verb";
}

&msg("Invoking: $command");

$rc = system("$command 2>&1");

print "\n";
&msg("Back from $command - rc=$rc - exiting");
exit 0;

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  #chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  #print "$date ${P} | $msgmsg\n";

  @sysdate = localtime;
  for ($i = 0; $i <= 5; $i++)
  {
    if (@sysdate[$i] < 10)
    {
      @sysdate[$i] = 0 . @sysdate[$i];
    }
  }
  $sysdate = @sysdate[5]+1900 . "/" . ++@sysdate[4] . "/" . @sysdate[3] . "-" . @sysdate[2] . ":" . @sysdate[1] . ":" . @sysdate[0];
  print "$sysdate ${P} | $msgmsg\n";
}

# --------------------------------------------------------------
#
# Subroutines
#
# --------------------------------------------------------------

sub dbError {
   local($errorMsg,@error_fields) = @_;
   print "======== D B   E r r o r   E n c o u n t e r e d =========\n";
   print "Error: DB Error Encountered While: $errorMsg\n";
   print "Error: DB Error String: $DBI::errstr\n";
   print "==========================================================\n";
   $dberror = 1;
   exit 1;
}

sub error
{
  $msg = $_[0];
  print "\n";
  print "$P | Fatal Error: $msg\n";
  print "Error: $msg\n";
  $date = `date`;
  print "$P | Exiting\n";
  exit 1;
}

# ----------------------------------------------------------------------
sub datafiles
# ----------------------------------------------------------------------
{
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify Oracle availability.
  print "$P | Connecting to Oracle driver=$driver\n";
  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass")
    || &dbError("Connect_To_DB");

  # Read from v$datafile;
  $sql = "select 
      d.name, 
      t.name,
      d.status
    from 
      v\$datafile d,
      v\$tablespace t
    where 
      d.ts# = t.ts# and
      status != 'SYSTEM' and 
      status != 'ONLINE'";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute || &dbError("Execute_Select");
  print "\n";
  while (@Data = $sth->fetchrow_array)
  {
    $dfname = $Data[0];
    $tsname = $Data[1];
    $status = $Data[2];
    print "OfflineDatafile: Tablespace=$tsname DFName=$dfname DFStatus=$status\n";
  }
  print "\n";
}

# ----------------------------------------------------------------------
sub ts      
# ----------------------------------------------------------------------
{
  $t_warn = $arg1;
  $t_crit = $arg2;
  $t_free = $arg3;
  $t_cmd  = $arg4;

  # Run SQL!
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify Oracle availability.
  print "$P | Connecting to Oracle driver=$driver\n";
  #$dbh = DBI->connect("DBI:ODBC:$driver" )
  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass")
    || &dbError("Connect_To_DB");

  if (!$dberror)
  {
    $sql = "
     select 
	    a.tablespace_name as tablespace_name,
	    d.contents,
	    a.sum_bytes as bytes_avail,
	    a.max_id,
	    nvl(b.sum_bytes,0) as bytes_used,
	    nvl(c.sum_bytes,0) as bytes_free,
	    round(nvl(b.sum_bytes,0.00) / a.sum_bytes * 100.0, 2) as pct_used,
	    d.status
       from 
	    ( select 
		tablespace_name,
		sum(bytes) sum_bytes,
		count(1) max_id
	      from 
		dba_data_files
	      group by 
		tablespace_name
	    ) a,
	    ( select 
		tablespace_name,
		sum(bytes) sum_bytes
	      from 
		dba_extents
	      group by 
		tablespace_name
	    ) b,
	    ( select 
		tablespace_name,
		sum(bytes) sum_bytes
	      from 
		dba_free_space
	      group by 
		tablespace_name
	    ) c,
	    dba_tablespaces d
      where a.tablespace_name = b.tablespace_name (+)
	and a.tablespace_name = c.tablespace_name (+)
	and a.tablespace_name = d.tablespace_name (+)
      ";

    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
   
    $verb = "Stack: orantTSStack";

    while (@Data = $sth->fetchrow_array)
    {
      $ts   = $Data[0];
      $type = substr($Data[1],0,4);
      $size = $Data[2]/1048576;
      $max  = $Data[3];
      $used = $Data[4]/1048576;
      $free = $Data[5]/1048576;
      $pct  = $Data[6];
      $stat = $Data[7];

      $sth2 = $dbh->prepare("select max(autoextensible) from dba_data_files where tablespace_name = '$ts'") || &dbError("Prepare");
      $sth2->execute || &dbError("Execute_Select");
      while (@Data2 = $sth2->fetchrow_array)
      {
	$autoextend = $Data2[0];
      }

      ##print "ts=$ts autoextend=$autoextend \n";

      $flag = "";
      # MB Needed to get to 5% below warning threshold
      $needed = int($used / (($t_warn-5)/100) - $size);
      if ($needed < 100)
      {
        $needed = 50;
      }
      if ($needed > 2000)
      {
        $needed = 2000;
      }
      
      if ($pct  >= $t_warn && $pct < $t_crit) { $flag = "W" . " " . $needed; }
      if ($pct  >= $t_crit )                  { $flag = "C" . " " . $needed; }
      if ($free >= $t_free)                   { $flag = "";  }
      if ($autoextend eq "YES") { $flag = "A"; } 

      print "ts=$ts pct=$pct t_warn=$t_warn t_crit=$t_crit flag=$flag \n";

      #printf("%s %-16s %8d %8d %8d %7.1f %s\n",$verb,$ts,$size,$used,$free,$pct,$flag);
      print "$verb $ts $type $max $size $used $free $pct $flag \n";
    }
    return;
  }
}

# ----------------------------------------------------------------------
sub arclogs
# ----------------------------------------------------------------------
{
  $t_warn = $arg1;
  $t_crit = $arg2;

  # Run SQL!
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify Oracle availability.
  print "$P | Connecting to Oracle driver=$driver\n";
  #$dbh = DBI->connect("DBI:ODBC:$driver" )
  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass")
    || &dbError("Connect_To_DB");

  if (!$dberror)
  {
    # Read from v$database
    $sql = "select log_mode from v\$database";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      print "Log_Mode: $Data[0]\n";
    }

    # Read from v$archive_dest
    $sql = "select destination from v\$archive_dest where length(destination) > 0";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      print "Log_Dest: $Data[0]\n";
      $logdrive = uc substr($Data[0],0,1);
      $logdrivedollar = "$logdrive\$";
      print "Log_Drive: $logdrive\n";
      $logdrivecount++;
    }
    print "Log_Drive_Count: $logdrivecount\n";

    if ($host eq "csenv01")
    {
      $ENV{'NTRESKIT'} = "c:\\reskit";
    }
    if ($host eq "spgqremw")
    {
      $ENV{'NTRESKIT'} = "e:\\reskit";
    }
    if ($host eq "wcoslgl3")
    {
      $ENV{'NTRESKIT'} = "d:\\reskit";
    }

    #$logdrivesize = (Win32::Driveinfo::DriveSpace($logdrive)) [5];
    #$logdrivefree = (Win32::Driveinfo::DriveSpace($logdrive)) [6];
    #print "size=$logdrivesize free=$logdrivefree \n";

    # See how full the $logdrive disk is 
    open(SRVINFO, '%NTRESKIT%\srvinfo -ns|') || print "Error: Running srvinfo";
    while(<SRVINFO>)
    {
      $srvinfo_ran = 1;
      print;
      @words = split;

      if ($words[0] eq $logdrivedollar) 
      {
        $srvinfo_found = 1;
        $logdrivesize = $words[2];
        $logdrivefree = $words[3];
        $logdriveused = $logdrivesize - $logdrivefree;
        $logdrivepct  = int(($logdriveused / $logdrivesize) * 100);
        print "Log_Drive_Size: $logdrivesize\n";
        print "Log_Drive_Free: $logdrivefree\n";
        print "Log_Drive_Used: $logdriveused\n";
        print "Log_Drive_Pct:  $logdrivepct\n";

        if    ($logdrivepct > $t_crit) { $logflag = "C"; }
        elsif ($logdrivepct > $t_warn) { $logflag = "W"; }
        else { $logflag = " "; }
        print "Log_Flag:  $logflag\n";
      }
    }
  } # end of !$dberror
  if (!$srvinfo_ran)
  {
    print "Log_Flag:  S   (%NTReskit%\srvinfo did not run)\n";
    system("set");
  }
  if (!$srvinfo_found)
  {
    print "Log_Flag:  S   (%NTReskit%\srvinfo did run, but did not find any information for disk $logdrivedollar - something is wrong)\n";
    print "\nNT Environment:\n";
    system("set");
  }
}

# ----------------------------------------------------------------------
sub up
# ----------------------------------------------------------------------
{
  # Get Server/OS Info
  print "$P Invoking net config server\n";
  open(SRVINFO, 'net config server|') 
    || print "$P Error $! Running net config server";
  while(<SRVINFO>)
  {
    ##print;
    @words = split;
    $verb1 = $words[0];
    $verb2 = $words[1];
    ##print "verb1=$verb1 verb2=$verb2\n";
    if ($verb1 eq "Software")
    {
      $osver = $words[4]; 
      print "OSVer: $osver\n";
    }
  }
  close(SRVINFO);
  print "NumCPUs: $ENV{'NUMBER_OF_PROCESSORS'}\n";
  $cpumodel = $ENV{'PROCESSOR_ARCHITECTURE'} . "," . $ENV{'PROCESSOR_LEVEL'};
  print "CPUModel: $cpumodel\n";

  # Get memory Info
  print "$P Invoking pstat\n";
  open(MEM, 'pstat 2>null |') 
    || print "$P Error $! Running pstat";
  while(<MEM>)
  {
    ##print;
    @words = split;
    $ram = int($words[4] / 1024);
    last;
  }
  close(MEM);
  if (defined($ram))
  {
    print "RAM: $ram\n";
  }

  # See if the agent is running
  open(NET, 'net start 2>null |') 
    || print "$P Error $! Running net start";
  while(<NET>)
  {
    ##print;
    @words = split;
    if (/TNSListener/)
    {
      $listener_running = 1;
      print "ListenerServiceRunning: Y\n";
    }
    if (uc $words[0] eq uc "OracleService$os")
    {
      $service_running = 1;
      print "OracleServiceRunning: Y\n";
    }
  }
  close(NET);

  if (!$service_running)
  {
    $dbstatus = "SERVICENOTACTIVE";
    print "DBStatus: $dbstatus\n";
  }

  # See if the agent is running
  #  Determine the name of the lsnrctl program
  if (-x "$oh\\bin\\lsnrctl80.exe")
  {
    $lsnrpgm = "lsnrctl80"; 
  }
  else
  {
    $lsnrpgm = "lsnrctl"; 
  }
  print "$P | Running $lsnrpgm\n";

  open(LSNR, "$lsnrpgm status |") 
    || print "Error: Running $lsnrpgm status";
  while(<LSNR>)
  {
    ##print;
    @words = split;
    if (/command completed successfully/)
    {
      $lsnrctl_running = 1;
      last;
    }
  }
  close(LSNR);

  $lsnr_status = "OK";
  if (!$lsnrctl_running) 
  {
    $lsnr_status = "LSNRCTL-NOT-OK";
  }
  if (!$listener_running) 
  {
    $lsnr_status = "LSNR-SERVICE-NOT-RUNNING";
  }
  print "LSNRStatus: $lsnr_status \n";
  if ($lsnr_status ne "OK")
  {
    return 1;
  }

  # Run SQL!
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify Oracle availability.
  print "$P | Connecting to Oracle driver=$driver\n";
  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass")
    || &dbError("Connect_To_DB");

  if (!$dberror)
  {
    # Read from dual
    $sql = "select dummy from dual";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $dbdual = $Data[0];
      print "DBDual: $dbdual\n";
    }

    # Read from v$instance
    $sql = "select version, status, logins from v\$instance";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $ver = $Data[0];
      $sta = $Data[1];
      $log = $Data[2];
      print "DBStatus: $sta\n";
      print "DBVersion: $ver\n";
      print "DBLogins: $log\n";
    }

    # Read from v$license
    $sql = "select SESSIONS_HIGHWATER from v\$license";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $hwm = $Data[0];
      print "SESSIONSHWM: $hwm\n";
    }

    # Get session userid
    $sql = "select user from dual";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $user = $Data[0];
    }
    print "Current_User: $user\n";

    # Get total bytes
    $sql = "select sum(bytes) from dba_data_files";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $tot_spacealloc = int($Data[0] / (1024*1024));
    }

    # Get total free
    $sql = "select sum(bytes) from dba_free_space";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $tot_spacefree = int($Data[0] / (1024*1024));
    }
    $tot_spaceused = $tot_spacealloc - $tot_spacefree;
    print "SpaceFree:  $tot_spacefree\n";
    print "SpaceAlloc: $tot_spacealloc\n";
    print "SpaceUsed:  $tot_spaceused\n";
 
  } # end of !$dberror

  # Decide status
  $dbstatus = "DOWN";

  if ($service_running && $dbdual eq "X" && $sta eq "OPEN")
  {
    $dbstatus = "UP";
  }
  if ($service_running && $log eq "RESTRICTED")
  {
    $dbstatus = "RESTRICTED";
  }
  if ($service_running && $dbdual ne "X")
  {
    $dbstatus = "SQLERROR";
  }

  print "DBStatus: $dbstatus \n";
}

# ----------------------------------------------------------------------
sub bkrun
# ----------------------------------------------------------------------
{
  $cmd = $arg1;
  print "$P bkrun: Issuing at now command to run backup:\n";
  print "$P bkrun: Command before {SID} substitution: $cmd\n";
  $cmd =~ s/\{SID\}/$os/g;
  $cmd = "echo 'time $cmd' | at now";
  print "$P bkrun: About to issue: $cmd\n";
  $rc = system($cmd);
  print "$P bkrun: Back from issuing at now - rc=$rc\n";
}

# ----------------------------------------------------------------------
sub bkup
# ----------------------------------------------------------------------
{
  # use strict;
  use DBI;

  print "$P | Connecting to Oracle driver=$driver\n";
  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass")
    || &dbError("Connect_To_DB");

  $sql = "select table_name from dba_tables where owner='DBAMON' and 
          table_name='BACKUP_AGE'";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute || &dbError("Execute_Select");
  while (@Data = $sth->fetchrow_array)
  {
     $bat_exists = "true";   
  }
 
 
  if ($bat_exists = "true")
  {
     # Read from dbamon.backup_age
     $sql = "select bcklevel, max(tsnum),tstext,elapsed 
       from 
         dbamon.backup_age
       where 
         sid =\'$os\' and bcklevel !=\'ARC\' 
         group by tstext,bcklevel,elapsed
         order by 2,3";
     $sth = $dbh->prepare("$sql") || &dbError("Prepare");
     $sth->execute || &dbError("Execute_Select");
     print "=======================================================\n";
     print "Backups Found in dbamon.backup_age:\n\n";

    $lvlage = 99999999;  # Age in hours of most recent LVL? backup
     while (@Data = $sth->fetchrow_array)
     {
       $bcklevel = @Data[0];
       $maxts    = @Data[1];
       $c_date   = @Data[2];
       $e_time   = @Data[3];
       $now = time();
       $agehrs   = ($now - $maxts) / 3600;
       $agehrs   = sprintf("%.0f", $agehrs);
       print "$P BACKUP_AGE: $bcklevel $agehrs\n";
       if (substr($bcklevel,0,3) eq "LVL")
       {
          $bktype = "bkRMAN";
          if ($agehrs < $lvlage) { $lvlage = $agehrs; }
       }
       if (substr($bcklevel,0,3) eq "EXP")
       {
          $bktype = "bkEXP";
          if ($agehrs < $lvlage) { $lvlage = $agehrs; }
       }
       if (substr($bcklevel,0,3) eq "TBS")
       {
          $bktype = "bkTBS";
          if ($agehrs < $lvlage) { $lvlage = $agehrs; }
       }
     }
     print "BckAge: $lvlage Type: $bktype CompletionTime: $c_date ElapsedMinutes: $e_time\n"; 
     $flag = 1;
  } 
  else
  {
     # Read from v$datafile;
     $sql = "select 
         s.backup_type, 
         s.incremental_level,
         to_char(s.completion_time,'YYYY/MM/DD-HH24:MI:SS'),
         s.elapsed_seconds / 60,
         (sysdate - s.completion_time) * 24
       from 
         v\$backup_set s
       where 
         s.backup_type in ('D','I')
       order by 5 desc
       ";
     $sth = $dbh->prepare("$sql") || &dbError("Prepare");
     $sth->execute || &dbError("Execute_Select");
     print "=======================================================\n";
     print "Backups Found in v\$backup_set:\n\n";
     while (@Data = $sth->fetchrow_array)
     {
       $ty = $Data[0];
       $lv = $Data[1];
       $ct = $Data[2];
       $es = int($Data[3]);
       $ag = int($Data[4]);
       print "BckAge: $ag Type: $ty Level: $lv CompletionTime: $ct ElapsedMinutes: $es\n";
       $flag = 1;
     }
   }
  if (!$flag)
  {
    print "BckAge: -1\n";
  }
  print "=======================================================\n";
}


# ----------------------------------------------------------------------
#
# Main
#
# ----------------------------------------------------------------------

$stime = time;

#
# Check to see if Oracle is 
#
if ($verb eq "up") 
{
  $subrc = &up();
  $subrc = &ts();
}

#
# Check to see if the listener is up - start it if not
#
if ($verb eq "datafiles") 
{
  $subrc = &datafiles();
}

#
# Backup age
#
if ($verb eq "bkup")
{
  $subrc = &bkup();
}

#
# Archive logs 
#
if ($verb eq "arclogs")
{
  $subrc = &arclogs();
}

#
# Terminate
#

$etime = time;
$elapsed = $etime - $stime;
print "$P DoneOK - elapsed: $elapsed - subrc: $subrc\n";

exit 0;
